import es
import time
import cmdlib
import playerlib
import soccer.soccer as soccerlib
from random import randint
from usermsg import hudhint
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Soccer Knives Script"
info.version = soccerlib.info.version
info.basename = "soccerknives"
info.author = "chrismrulz"

soccerlib.restrictstat('Excessive Knifing')
max_knives = int(soccerlib.config["Knives"]["max_knives"])
warn_at_knives = int(soccerlib.config["Knives"]["warn_at_knives"])
msgmode = int(soccerlib.config["Knives"]["msgmode"])
autoslay = int(soccerlib.config["Knives"]["autoslay"])
knifereset = soccerlib.config["Knives"]["knifereset"]
knifeslap = soccerlib.config["Knives"]["knifeslap"]
kcsoundslist = soccerlib.config["Knives"]
kcsounds = {}
for i in kcsoundslist:
	ksnumber = i.replace('knife', '')
	try:
		kcsounds[int(ksnumber)] = kcsoundslist[i]
		soccerlib.addsound(kcsoundslist[i])
	except:
		pass
kcsoundslist = None

def load():
 	es.msg('#Green','Soccer Knife Script On - by Toph')
	loadblock()

def unload():
 	cmdlib.unregisterClientCommand('knifecount')
 	cmdlib.unregisterSayCommand('!knifecount')
 	es.msg('#Green','Soccer Knife Script Off')

def es_map_start(event_var):
 	loadblock()

def loadblock():
	if(es.exists('clientcommand', 'knifecount') != 1):
		cmdlib.registerClientCommand('knifecount', knifecountsay, 'Shows the amount of knives the player has done in the past minute')
	if(es.exists('saycommand', '!knifecount') != 1):
		cmdlib.registerSayCommand('!knifecount', knifecountsay, 'Shows the amount of knives the player has done in the past minute')

def getmsgmode(steamid):
	if(steamid not in soccerlib.players):
		return msgmode
	else:
		if('knifemsgmode' not in soccerlib.players[steamid]):
			return msgmode
		else:
			return soccerlib.players[steamid]['knifemsgmode']

def getknifesounds(steamid):
	if(steamid not in soccerlib.players):
		return 0
	else:
		if('knifesounds' not in soccerlib.players[steamid]):
			return 0
		else:
			return soccerlib.players[steamid]['knifesounds']

def round_start(event_var):
 	global pa
 	pa = {}

def warn_action(userid, steamid, knives):
 	if(getknifesounds(steamid) == 0):
 	 	limitsounds(userid, knives)
 	umsgmode = getmsgmode(steamid)
 	if(umsgmode == 0):
 		if(autoslay == 1):
 	 		es.menu(4, userid, 'You have knifed %s times in 1 minute. Stop knifing or you will be slayed.' % knives)
 		else:
 	 		playerfoulmsay(userid, knives)
 	elif(umsgmode == 1):
 		if(autoslay == 1):
 	 		hudhint(userid, 'You have knifed %s times in 1 minute. Stop knifing or you will be slayed.' % knives)
 		else:
 	 		playerhh(userid, knives)
 	elif(umsgmode == 2):
 		if(autoslay == 1):
 	 		es.tell(userid, '#multi', '#greenYou have knifed#lightgreen %s #greentimes in 1 minute. Stop knifing or you will be slayed.' % knives)
 		else:
 	 		playerfoultell(userid, knives)

def limit_reached_action(userid, steamid, name, knives):
 	if(es.getInt('soccerstats_enabled') == 1):
 	 	soccerlib.incstat(steamid, name, 'Excessive Knifing')
 	if(getknifesounds(steamid) == 0):
 	 	limitsounds(userid, knives)
 	umsgmode = getmsgmode(steamid)
 	speclist = playerlib.getPlayerList('#spec,#un')
 	if(autoslay == 1):
 		soccerlib.slay(userid)
 	if(umsgmode == 0):
 		if(autoslay == 1):
 			es.menu(4, userid, 'You have been slayed for excessive knifing.')
 		else:
 			playerfoulmsay(userid, knives)
 		for ply in speclist:
			es.menu(10, ply.userid, '%s has committed %s fouls.' % (name, knives))
 	elif(umsgmode == 1):
 		if(autoslay == 1):
 			hudhint(userid, 'You have been slayed for excessive knifing.')
 		else:
 			playerhh(userid, knives)
		for ply in speclist:
 			spechh(ply.userid, name, knives)
 	elif(umsgmode == 2):
 		if(autoslay == 1):
 			es.msg('#multi', '#greenPlayer#lightgreen %s #greenslayed for excessive knifing.' % name)
 		else:
 			playerfoultell(userid, knives)
 			for ply in speclist:
 				es.tell(ply.userid, '#multi', '#greenPlayer#lightgreen %s #greenhas committed#lightgreen %s #greenfouls.' % (name, knives))

def playerfoultell(userid, knives):
 	es.tell(userid, '#multi', '#greenYou have commited#lightgreen %s #greenfouls.' % knives)

def playerfoulmsay(userid, knives):
 	es.menu(4, userid, 'You have committed %s fouls.' % knives)

def playerhh(userid, knives):
	hudhint(userid, 'You have commited %s fouls.' % knives)

def spechh(userid, name, knives):
 	hudhint(userid, '%s has commited %s fouls.' % (name, knives))

def playerresetmsay(userid, time):
 	es.menu(10, userid, 'Your previous knife count was reset %s seconds ago.' % time)

def knifecount(userid, steamid):
 	umsgmode = getmsgmode(steamid)
	if(pa[userid] == []):
		lrmsg = 'Your previous knife count was reset because you reached the limit.'
		if(getknifesounds(steamid) != 1):
			es.playsound(userid, knifereset, 1.0)
		if(umsgmode == 0):
			es.menu(10, userid, lrmsg)
		elif(umsgmode == 1):
			hudhint(userid, lrmsg)
		elif(umsgmode == 2):
			es.tell(userid, '#green', lrmsg)
		return
	totalknives = len(pa[userid])
	lntime = int(pa[userid][totalknives-1])
	fktime = 0
	count = 0
	for pktime in pa[userid]:
		if(lntime - pktime <= 60):
			count += 1
			if(fktime == 0):
				fktime = 60 - (int(time.time()) - pktime)
	if(fktime <= 0):
		pt = str(fktime).replace('-', '')
		#pt = int(str(lntime - int(time.time())).replace('-', '')) - 60
		if(getknifesounds(steamid) != 1):
			es.playsound(userid, knifereset, 1.0)
		if(umsgmode == 0):
			playerresetmsay(userid, pt)
		elif(umsgmode == 1):
			hudhint(userid, 'Your previous knife count was reset %s seconds ago.' % pt)
		elif(umsgmode == 2):
			es.tell(userid, '#multi', '#greenYour previous knife count was reset#lightgreen %s #greenseconds ago.' % pt)
	else:
		if(umsgmode == 0):
			es.menu(10, userid, 'You have knifed %s times.\nYou have %s seconds remaining until you can knife again.' % (count, fktime))
		elif(umsgmode == 1):
			hudhint(userid, 'Your have knifed %s times. You have %s seconds remaining until you can knife again.' % (count, fktime))
		elif(umsgmode == 2):
			es.tell(userid, '#multi', '#greenYou have knifed#lightgreen %s #greentimes. You have#lightgreen %s #greenseconds remaining until you can knife again.' % (count, fktime))
		if(getknifesounds(steamid) != 1):
			limitsounds(userid, count)

def knifecountsay(userid, args):
 	steamid = es.getplayersteamid(userid)
 	umsgmode = getmsgmode(steamid)
 	noknifemsg = 'You have not yet knifed this round.'
	if(userid in pa):
 		knifecount(userid, steamid)
 	else:
 		if(getknifesounds(steamid) != 1):
 			es.playsound(userid, knifereset, 1)
 		if(umsgmode == 0):
 			es.menu(10, userid, noknifemsg)
 		elif(umsgmode == 1):
 			hudhint(userid, noknifemsg)
 		elif(umsgmode == 2):
 			es.tell(userid, '#green', noknifemsg)

def slap(userid):
	es.emitsound("player", userid, knifeslap, '1.0', '0.5')
	es.setplayerprop(userid, 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', '%s,%s,%s'%(randint(-255, 255), randint(-255, 255), 255))

def player_hurt(event_var):
 	if(event_var['weapon'] == 'knife'):
 		global pa
		userid = int(event_var['attacker'])
		steamid = event_var['es_attackersteamid']
		name = event_var['es_attackername']
		curtime = int(time.time())
 		slap(userid)
		if(userid not in pa):
 			pa[userid] = [curtime]
 		else:
 			pa[userid].append(curtime)
		count = 0
		for pktime in pa[userid]:
			if(curtime - pktime <= 60):
				count += 1
		if(count == warn_at_knives):
			warn_action(userid, steamid, count)
		elif(count >= max_knives):
			limit_reached_action(userid, steamid, name, count)
			del pa[userid][:]

def limitsounds(userid, knives):
	if(knives in kcsounds):
		es.playsound(userid, kcsounds[knives], 1)